#include <som.hh>   

//
// All SOM classes must directly or indirectly inherit from class SOMObject.
//

#ifndef EXorIMP_Info
#define EXorIMP_Info _Import
#endif

class EXorIMP_Info Info : public SOMObject
{
//
// Specify the SOM name for a class, as it would appear in IDL, using 
// pragma SOMClassName. Otherwise, Info's SOM class name would be z-mangled 
// to zinfo.
//

   #pragma SOMClassName(*, "info")
   public:

//
// All SOM classes must declare a default constructor. If you don't specify
// one, VA for C++ automatically declares one for you.
//

      Info();

//
// To access instance data indirectly via get/set methods use pragma 
// SOMAttribute.
//

      short    x;
      #pragma SOMAttribute(x)

      char     y;
      #pragma SOMAttribute(y)

//
// To ensure version-to-version backwards binary-compatibility between 
// a changing class definition, use pragma SOMReleaseOrder.
//

#pragma SOMReleaseOrder( x, y )
};

