///////////////////////////////////////////////////////////////////////////////
//                          SAMPLE CODE
//
// FileName: ACDFMy2.hpp
//
// ClassName: ACompDocFwkMyObject
//
// Description: Header file for the Compound Document Framework 
//              MyObject
///////////////////////////////////////////////////////////////////////////////
#ifndef _MYOBJECT_
#define _MYOBJECT_

#ifdef IC_TRACE_DEVELOP
     #include <itrace.hpp>
#else
     #define IFUNCTRACE_DEVELOP()
     #define ITRACE_DEVELOP(x)
#endif

#include <istring.hpp>

class ACompDocFwkMyObject
{
public:
     TypeExtensionDeclarationsMacro(ACompDocFwkMyObject)

                            ACompDocFwkMyObject();
                            ACompDocFwkMyObject(IString myStr);
     virtual                ~ACompDocFwkMyObject();

     virtual IString        getMyString() const;
     virtual Boolean        setMyString(const IString&);

     virtual IBaseStream&   operator>>=( IBaseStream& towhere ) const;
     virtual IBaseStream&   operator<<=( IBaseStream& fromwhere );

protected:
                            ACompDocFwkMyObject(const ACompDocFwkMyObject&);

private:
     enum                   { kOriginalVersion };
     ACompDocFwkMyObject&   operator=(const ACompDocFwkMyObject&);

     IString                fMyString;
};

#endif
