///////////////////////////////////////////////////////////////////////////////
//                      SAMPLE CODE
//
// FileName: ACDFMdl3.hpp
//
// ClassName: ACompDocFwkModel
//
// Description: Compound Document Framework Simple Container Model Header file  
//              for the container. This sample is the basic container. 
//              By inheriting from IEmbedder class the functionality to insert 
//              an object is all inherited, therefore this sample contains very
//              little. There is no model data, only streaming is provided.
///////////////////////////////////////////////////////////////////////////////
#ifndef _COMPDOCFWK_MODEL_      
#define _COMPDOCFWK_MODEL_

#ifdef IC_TRACE_DEVELOP
    #include <itrace.hpp>
#else
    #define IFUNCTRACE_DEVELOP()
    #define ITRACE_DEVELOP(x)
#endif

#include <iembmod.hpp>

class ACompDocFwkModel : public IEmbedderModel // Inherits from IEmbedderModel
{
public:
    TypeExtensionDeclarationsMacro(ACompDocFwkModel)

                                ACompDocFwkModel();
    virtual                     ~ACompDocFwkModel();

    virtual IBaseStream&        operator>>=( IBaseStream& towhere ) const;
    virtual IBaseStream&        operator<<=( IBaseStream& fromwhere );

protected:
                                ACompDocFwkModel( const ACompDocFwkModel&);

private:
    enum                        { kOriginalVersion };
    ACompDocFwkModel&           operator=(const ACompDocFwkModel&);
};

#endif
    
