///////////////////////////////////////////////////////////////////////////////
//                      SAMPLE CODE
//
// FileName: ACDFMdl4.hpp
//
// ClassName: ACompDocFwkModel
//
// Description: Compound Document Framework header file for the model container
//                     This sample container model conatins no data of its own
//                     Basic functionality is inherited from the base class.
///////////////////////////////////////////////////////////////////////////////
#ifndef _COMPDOCFWK_MODEL_
#define _COMPDOCFWK_MODEL_

#ifdef IC_TRACE_DEVELOP
      #include <itrace.hpp>
#else
      #define IFUNCTRACE_DEVELOP()
      #define ITRACE_DEVELOP(x)
#endif

#include <iembmod.hpp>

// For the container inherit from the emdedder class
class ACompDocFwkModel : public IEmbedderModel   
{
public:
      TypeExtensionDeclarationsMacro(ACompDocFwkModel)

                                ACompDocFwkModel();
      virtual                   ~ACompDocFwkModel();

      virtual IBaseStream&      operator>>=( IBaseStream& towhere ) const;
      virtual IBaseStream&      operator<<=( IBaseStream& fromwhere );

protected:
                                ACompDocFwkModel( const ACompDocFwkModel&);

private:
      enum                      { kOriginalVersion };
      ACompDocFwkModel&          operator=(const ACompDocFwkModel&);
};

#endif
      
