///////////////////////////////////////////////////////////////////////////////
//                      SAMPLE CODE
//
// FileName: ACDFSt4.hpp
//
// ClassName: ACompDocFwkMyStationery
//
// Description: This is the stationery class. The only reason the stationery
//              class is overridden is to override the createBundle class.
//              In the overridden createBundle a ACompDocFwkBundle type 
//              class in created instead of the default IGUIBundle. 
///////////////////////////////////////////////////////////////////////////////
#ifndef _COMPDOCFWK_STATIONERY_
#define _COMPDOCFWK_STATIONERY_

#ifdef IC_TRACE_DEVELOP
    #include <itrace.hpp>
#else
    #define IFUNCTRACE_DEVELOP()
    #define ITRACE_DEVELOP(x)
#endif

class ACompDocFwkModel;
class ACompDocFwkView;

#include <istatnry.hpp>


class ACompDocFwkMyStationery : public IComponentStationeryFor <ACompDocFwkModel,ACompDocFwkView>
{
public:
                                        ACompDocFwkMyStationery();
                                        ~ACompDocFwkMyStationery();

    // only method to  override
    virtual IGUIBundle*                 createBundle() const;
};


#endif
