///////////////////////////////////////////////////////////////////////////////
//                    	SAMPLE CODE
//
// FileName: ACDFBd5.cpp
//
// ClassName: ACompDocFwkMyBundle
//
// Description: This is the bundle class. The reason a user version of the 
//              IGUIbundle class is created is to override the bundle menu handling.
//              For example in this case handling SelectAll and FileNew methods
//              have been overridden so that the view class will be called when
//              the user has selected either of these menu options.
///////////////////////////////////////////////////////////////////////////////
#include "ACDFBd5.hpp"
#include "ACDFVw5.hpp"

ACompDocFwkMyBundle::ACompDocFwkMyBundle()
// Constructor
{   IFUNCTRACE_DEVELOP();}

ACompDocFwkMyBundle::~ACompDocFwkMyBundle()
// Destructor
{   IFUNCTRACE_DEVELOP();}

void ACompDocFwkMyBundle::handleSelectAll( Boolean selectAll)
// Override this method and call the View's handleSelectAll and the
// base class method
{   IFUNCTRACE_DEVELOP();

    ACompDocFwkView* theView;
    theView = (ACompDocFwkView*)&objectView();
    theView->handleSelectAll(selectAll);

    IGUIBundle::handleSelectAll(selectAll);

}
void ACompDocFwkMyBundle::handleFileNew( )
// Override this method and call the View's handleFileNew and the
// base class method
{   IFUNCTRACE_DEVELOP();

    ACompDocFwkView* theView;
    theView = (ACompDocFwkView*)&objectView();
    theView->handleFileNew();

    IGUIBundle::handleFileNew();
}
