///////////////////////////////////////////////////////////////////////////////
//                    	SAMPLE CODE
//
// FileName: ACDFBd5.hpp
//
// ClassName: ACompDocFwkMyBundle
//
// Description: This is the bundle class. The reason a user version of the 
//              IGUIbundle class is created is to override the bundle menu handling.
//              For example in this case handling SelectAll and FileNew methods
//              have been overridden so that the view class will be called when
//              the user has selected either of these menu options.
///////////////////////////////////////////////////////////////////////////////
#ifndef _COMPDOCFWK_BUNDLE_
#define _COMPDOCFWK_BUNDLE_

#ifdef IC_TRACE_DEVELOP
    #include <itrace.hpp>
#else
    #define IFUNCTRACE_DEVELOP()
    #define ITRACE_DEVELOP(x)
#endif

#include <iguibndl.hpp>

class ACompDocFwkMyBundle : public  IGUIBundle
{
public:
                                ACompDocFwkMyBundle();
                                ~ACompDocFwkMyBundle();

    // Override the menu command from the guibundle!!!
    virtual void                handleSelectAll( Boolean );
    virtual void                handleFileNew();
};

#endif
