#
#   COMPONENT_NAME: somx
#
#   ORIGINS: 27
#
#
#   10H9767, 10H9769  (C) COPYRIGHT International Business Machines Corp. 1992,1994
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.




# DISCLAIMER OF WARRANTIES.
# The following [enclosed] code is sample code created by IBM
# Corporation. This sample code is not part of any standard or IBM
# product and is provided to you solely for the purpose of assisting
# you in the development of your applications.  The code is provided
# "AS IS". IBM MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT
# NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE, REGARDING THE FUNCTION OR PERFORMANCE OF
# THIS CODE.  IBM shall not be liable for any damages arising out of
# your use of the sample code, even if they have been advised of the
# possibility of such damages.
#
# DISTRIBUTION.
# This sample code can be freely distributed, copied, altered, and
# incorporated into other software, provided that it bears the above
# Copyright notice and DISCLAIMER intact.

!include ..\..\..\mscmake.hd

INCS = -I$(SOMBASE)\include
INCLS = stack.xh
IDLFILES = stack.idl

PRIVCPPFLAGSDLL=/DSOM_DONT_IMPORT_CLASS_Stack
PRIVCPPFLAGS=

DLLOBJS=stack.od stackini.od nlsutil.od
PRIVLDFLAGSDLL=$(ENTRYFLAG) $(SOMINITOBJ)
PRIVDLLLIBS=gdi32.lib

CLEANFILES=stack.def

all: $(SOMXH_DEPEND) stack.dll somstack.exe som.ir somdimpl

stack.def: stack.idl
stack.lib: stack.def $(DLLOBJS)
stack.dll: stack.def $(DLLOBJS) stack.lib
stack.od: stack.xih stack.xh stack.cpp
stackini.od: stackini.cpp

somstack.exe: somstack.obj nlsutil.obj stack.lib somstack.res
somstack.obj: $(INCLS) somstack.cpp
somstack.res : somstack.rc somstack.h

### -- Put the IDL descriptions into the Interface Repository.
som.ir: som_ir

som_ir: stack.idl
	-$(SC) -sir -u -mnolock $(INCS) *.idl
	echo x > som_ir

clnimpl:
	-regimpl -D -i stackServer2
	-del somdimpl

### -- Build the DSOM Implementation Repository.
somdimpl:
	-regimpl -A -i stackServer2
	-regimpl -a -i stackServer2 -c Stack 
	-regimpl -L -i stackServer2
	-regimpl -l -i stackServer2
	@echo x > somdimpl

clean: clnimpl
	del som.ir
	del som_ir

!include ..\..\..\mscmake.tl
